JmsActivationSpecConfig (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.jms.listener.endpoint

## Class JmsActivationSpecConfig

- java.lang.Object
- - org.springframework.jms.listener.endpoint.JmsActivationSpecConfig

-     public class JmsActivationSpecConfig
      extends Object

  Common configuration object for activating a JMS message endpoint. Gets converted into a provider-specific JCA 1.5 ActivationSpec object for activating the endpoint.

  Typically used in combination with `JmsMessageEndpointManager`, but not tied to it.

  Since:
    2.5
  Author:
    Juergen Hoeller
  See Also:
    `JmsActivationSpecFactory`, `JmsMessageEndpointManager.setActivationSpecConfig(org.springframework.jms.listener.endpoint.JmsActivationSpecConfig)`, `ResourceAdapter.endpointActivation(javax.resource.spi.endpoint.MessageEndpointFactory, javax.resource.spi.ActivationSpec)`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `JmsActivationSpecConfig()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getAcknowledgeMode()` Return the JMS acknowledgement mode to use.
    `String` | `getClientId()`
    `String` | `getDestinationName()`
    `String` | `getDurableSubscriptionName()`
    `int` | `getMaxConcurrency()` Return the maximum number of consumers/sessions to use.
    `String` | `getMessageSelector()`
    `int` | `getPrefetchSize()` Return the maximum number of messages to load into a session.
    `boolean` | `isPubSubDomain()`
    `boolean` | `isSubscriptionDurable()`
    `void` | `setAcknowledgeMode(int acknowledgeMode)` Set the JMS acknowledgement mode to use.
    `void` | `setAcknowledgeModeName(String constantName)` Set the JMS acknowledgement mode by the name of the corresponding constant in the JMS `Session` interface, e.g.
    `void` | `setClientId(String clientId)`
    `void` | `setConcurrency(String concurrency)` Specify concurrency limits via a "lower-upper" String, e.g.
    `void` | `setDestinationName(String destinationName)`
    `void` | `setDurableSubscriptionName(String durableSubscriptionName)`
    `void` | `setMaxConcurrency(int maxConcurrency)` Specify the maximum number of consumers/sessions to use, effectively controlling the number of concurrent invocations on the target listener.
    `void` | `setMessageSelector(String messageSelector)`
    `void` | `setPrefetchSize(int prefetchSize)` Specify the maximum number of messages to load into a session (a kind of batch size).
    `void` | `setPubSubDomain(boolean pubSubDomain)`
    `void` | `setSubscriptionDurable(boolean subscriptionDurable)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### JmsActivationSpecConfig

          public JmsActivationSpecConfig()

  - ### Method Detail

    - #### setDestinationName

          public void setDestinationName(String destinationName)

    - #### getDestinationName

          public String getDestinationName()

    - #### setPubSubDomain

          public void setPubSubDomain(boolean pubSubDomain)

    - #### isPubSubDomain

          public boolean isPubSubDomain()

    - #### setSubscriptionDurable

          public void setSubscriptionDurable(boolean subscriptionDurable)

    - #### isSubscriptionDurable

          public boolean isSubscriptionDurable()

    - #### setDurableSubscriptionName

          public void setDurableSubscriptionName(String durableSubscriptionName)

    - #### getDurableSubscriptionName

          public String getDurableSubscriptionName()

    - #### setClientId

          public void setClientId(String clientId)

    - #### getClientId

          public String getClientId()

    - #### setMessageSelector

          public void setMessageSelector(String messageSelector)

    - #### getMessageSelector

          public String getMessageSelector()

    - #### setAcknowledgeModeName

          public void setAcknowledgeModeName(String constantName)

      Set the JMS acknowledgement mode by the name of the corresponding constant in the JMS `Session` interface, e.g. "CLIENT_ACKNOWLEDGE".

      Note that JCA resource adapters generally only support auto and dups-ok (see Spring's `StandardJmsActivationSpecFactory`). ActiveMQ also supports "SESSION_TRANSACTED" in the form of RA-managed transactions (automatically translated by Spring's `DefaultJmsActivationSpecFactory`.

      Parameters:
        `constantName` - the name of the `Session` acknowledge mode constant
      See Also:
        `Session.AUTO_ACKNOWLEDGE`, `Session.CLIENT_ACKNOWLEDGE`, `Session.DUPS_OK_ACKNOWLEDGE`, `Session.SESSION_TRANSACTED`, `StandardJmsActivationSpecFactory`, `DefaultJmsActivationSpecFactory`

    - #### setAcknowledgeMode

          public void setAcknowledgeMode(int acknowledgeMode)

      Set the JMS acknowledgement mode to use.
      See Also:
        `Session.AUTO_ACKNOWLEDGE`, `Session.CLIENT_ACKNOWLEDGE`, `Session.DUPS_OK_ACKNOWLEDGE`, `Session.SESSION_TRANSACTED`

    - #### getAcknowledgeMode

          public int getAcknowledgeMode()

      Return the JMS acknowledgement mode to use.

    - #### setConcurrency

          public void setConcurrency(String concurrency)

      Specify concurrency limits via a "lower-upper" String, e.g. "5-10", or a simple upper limit String, e.g. "10".

      JCA listener containers will always scale from zero to the given upper limit. A specified lower limit will effectively be ignored.

      This property is primarily supported for configuration compatibility with `DefaultMessageListenerContainer`. For this activation config, generally use `setMaxConcurrency(int)` instead.

    - #### setMaxConcurrency

          public void setMaxConcurrency(int maxConcurrency)

      Specify the maximum number of consumers/sessions to use, effectively controlling the number of concurrent invocations on the target listener.

    - #### getMaxConcurrency

          public int getMaxConcurrency()

      Return the maximum number of consumers/sessions to use.

    - #### setPrefetchSize

          public void setPrefetchSize(int prefetchSize)

      Specify the maximum number of messages to load into a session (a kind of batch size).

    - #### getPrefetchSize

          public int getPrefetchSize()

      Return the maximum number of messages to load into a session.